package net.ibizsys.central.plugin.boot.core.service.impl;

import net.ibizsys.central.plugin.boot.core.domain.BaseData;
import net.ibizsys.central.plugin.boot.core.filter.BaseFilter;
import net.ibizsys.central.plugin.boot.core.runtime.BootServiceImpl;
import net.ibizsys.central.plugin.boot.core.runtime.IBootService;
import net.ibizsys.central.plugin.boot.core.service.IBaseService;
import javax.annotation.PostConstruct;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

public  abstract class BaseServiceImpl<T extends BaseData, F extends BaseFilter> implements IBaseService<T, F> {

    private IBootService runtimeService;
    @Override
    public IBootService getRuntimeService(){
        return runtimeService;
    }

    public void setRuntimeService(IBootService runtimeService) {
        this.runtimeService = runtimeService;
    }

    @PostConstruct
    private void postConstruct() throws Exception {
        runtimeService = new BootServiceImpl<T,F>(this);
    }

    private Object lockMethods = new Object();

    private Map<String, Method> serviceMethods=new HashMap<>();

    public Method getServiceMethod(String name,Class clazz) {
        Method method = null;
        synchronized (lockMethods)
        {
            String tag=name;
            if(clazz.isArray())
                tag=tag+"List";
            if(serviceMethods.containsKey(tag))
                return serviceMethods.get(tag);

            try {
                method=this.getClass().getMethod(name,clazz);

            } catch (NoSuchMethodException e) {
            }
            serviceMethods.put(tag,method);

        }
        return method;
    }

}

